/*
 Programa Ŀ
   Aplicacin: Funciones para construccin de objetos TReport TRColumn    
      Fichero: PDREPORT.PRG                                               
        Autor: Ignacio Ortiz de Ziga Echeverra                         
        Fecha: 24/05/94                                                   
         Hora: 14:28:13                                                   
    Make File:                                                            
    Exec File:                                                            
    Copyright: 1994 by Ortiz de Zuiga, S.L.                              

*/

#include "objects.ch"
#include "common.ch"

#define REPORT  1
#define COLUMNS 2

static aReports := {}

/*
 Funcin Ŀ
  Descripcin: Inicializa la definicin de un report                      
        Autor: Ignacio Ortiz de Ziga Echeverra                         
        Fecha: 24/05/94                                                   
         Hora: 14:01:25                                                   
    Copyright: Ortiz de Zuiga, S.L.                                      
Ĵ
     Function: RptBegin                                                   
                                                                          
   Argumentos: ver ms abajo                                              
                                                                          
 Valor Return: oReport                                                    
  Ver tambin:                                                            
                                                                          

*/
Function RptBegin(nWidht   ,;                    // Ancho
                  nHeight  ,;                    // largo
                  aTitle   ,;                    // matriz de bTitulos
                  aHead    ,;                    // matriz de bHead
                  aFoot    ,;                    // matriz de bFoot
                  aFont    ,;                    // matriz de oFont
                  cRptfile ,;                    // Nombre fichero
                  cResName  )                    // Nombre recursos

   AAdd( aReports ,;
        { TReport():New(nWidht   ,;
                        nHeight  ,;
                        aTitle   ,;
                        aHead    ,;
                        aFoot    ,;
                        aFont    ,;
                        cRptfile ,;
                        cResName  ), {} } )

Return ATail( aReports )[ REPORT ]

/*
 Funcin Ŀ
  Descripcin: Aade un grupo de ordenacin al report en curso            
        Autor: Ignacio Ortiz de Ziga Echeverra                         
        Fecha: 24/05/94                                                   
         Hora: 14:01:42                                                   
    Copyright: Ortiz de Zuiga, S.L.                                      
Ĵ
     Function: RptAddGroup                                                
                                                                          
   Argumentos: bGroup   -> Expresin del grupo                            
               lSummary -> si .T. slo resumen                            
               lEject   -> si .T. salto de pgina                         
 Valor Return:                                                            
  Ver tambin:                                                            
                                                                          

*/
Function RptAddGroup(bGroup, lSummary, lEject)

     Atail(aReports)[ REPORT ]:AddGroup(bGroup, lSummary, lEject)

Return (NIL)

/*
 Funcin Ŀ
  Descripcin: Aade columnas al Report                                   
        Autor: Ignacio Ortiz de Ziga Echeverra                         
        Fecha: 24/05/94                                                   
         Hora: 14:18:04                                                   
    Copyright: Ortiz de Zuiga, S.L.                                      
Ĵ
     Function: RptAddColumn                                               
                                                                          
   Argumentos: ver ms abajo                                              
                                                                          
 Valor Return: oColumn                                                    
  Ver tambin:                                                            
                                                                          

*/
Function RptAddColumn(aTitle     ,;              // matriz de bTitulos
                      nCol       ,;              // columna
                      aData      ,;              // matriz de bData
                      nSize      ,;              // ancho de la columna
                      aPicture   ,;              // matriz de cPictures
                      uFont      ,;              // bFont=>n | n (nId Font)
                      lTotal     ,;              // lgico de total
                      bTotalExpr  )              // bExpr de condicin de total

     Local oColumn

     oColumn := TRColumn():New(aTitle     ,;
                               nCol       ,;
                               aData      ,;
                               nSize      ,;
                               aPicture   ,;
                               uFont      ,;
                               lTotal     ,;
                               bTotalExpr ,;
                               Atail(aReports)[ REPORT ] )

     AAdd( ATail( aReports )[ COLUMNS ], oColumn )

return oColumn

/*
 Funcin Ŀ
  Descripcin: Finaliza la definicin del report                          
        Autor: Ignacio Ortiz de Ziga Echeverra                         
        Fecha: 24/05/94                                                   
         Hora: 14:28:06                                                   
    Copyright: Ortiz de Zuiga, S.L.                                      
Ĵ
     Function: RptEnd                                                     
                                                                          
   Argumentos:                                                            
                                                                          
 Valor Return: oReport                                                    
  Ver tambin:                                                            
                                                                          

*/
Function RptEnd()

   local oReport  := ATail( aReports )[ REPORT ]
   local aColumns := ATail( aReports )[ COLUMNS ]

   AEval( aColumns, { | oColumn | oReport:AddColumn( oColumn ) } )

   ASize( aReports, Len( aReports ) - 1 )

   oReport:Stabilize()

Return oReport

// eof
